<template>
  <div class="relative block w-auto">
    <label v-if="label.length > 0" class="mb-2">{{ label }}:</label>
    <button
      type="button"
      class="flex w-full appearance-none flex-row items-center gap-x-4 rounded border bg-ec-other-white px-4 py-2 leading-tight text-ec-dark-100 shadow focus:shadow-ec-primary focus:outline-none focus:outline focus:outline-ec-primary"
      @click="isSelectionOpen = !isSelectionOpen"
    >
      <span v-if="currentValue.length">
        {{ options.find((o) => o.key === currentValue)?.label }}
      </span>
      <span v-else>{{ placeholder }}</span>

      <SIcon
        name="corner-arrow"
        class="ml-auto h-full max-h-5 w-5"
        :class="isSelectionOpen ? '' : 'rotate-180 transition-transform duration-150'"
      />
    </button>
    <SDropdown
      :options="options"
      :is-open="isSelectionOpen"
      @select="selectValue"
      class="absolute left-0 top-full z-10 w-full bg-white"
    >
      <template #option="{ label, key }">
        <slot name="option" :label="label" :key="key">
          <div :data-value="key">{{ label }}</div>
        </slot>
      </template>
    </SDropdown>
  </div>
</template>

<script setup lang="ts">
import { type PropType, ref, watch } from 'vue';
import SIcon from './SIcon.vue';
import SDropdown from './SDropdown.vue';

const isSelectionOpen = ref(false);

const emit = defineEmits<{
  (e: 'change', key: string): void;
  (e: 'input', key: string): void;
}>();

const selectValue = (key: string) => {
  currentValue.value = key;
  emit('change', key);
  emit('input', key);
  isSelectionOpen.value = false;
};

const props = defineProps({
  label: {
    type: String,
    default: '',
  },
  placeholder: {
    type: String,
    default: '',
  },
  options: {
    type: Array as PropType<{ label: string; key: string }[]>,
    default: () => [],
  },
  value: {
    type: String,
    default: '',
  },
});

const currentValue = defineModel<string>({ default: '' });

if (props.placeholder.length === 0 && props.value.length === 0 && props.options.length > 0) {
  selectValue(props.options[0].key);
}

watch(
  () => props.value,
  (newValue: string) => {
    selectValue(newValue);
  }
);
</script>
